import Events, Logger
import popen2, fcntl, os

class Process(Events.EventSource):

    def __init__(self, command, context):
	self._proc = popen2.Popen4(command)
	fcntl.fcntl(self._proc.fromchild, fcntl.F_SETFL, os.O_NDELAY)
	Events.EventSource.__init__(self, self._proc.fromchild, context)
	self._buffer = ""
	Logger.log(self.context(),"launched %s" % command)

    def readEvents(self):
	data = (self._buffer + self._proc.fromchild.read()).split('\n')
	self._buffer = data.pop(-1)
	for line in data:
	    Logger.log(self.context(), line)
	rv = self.poll()
	if rv != -1 : self._term(rv)
	return []

    def terminate(self):
        os.kill(self._proc.pid,signal.SIGTERM)
	self._term(self._proc.wait())

    def _term(self, rv):
	if self._buffer : Logger.log(self.context(),self._buffer)
	self._buffer = ""
	Logger.log(self.context(), 'Terminated with exit code %s' % rv)
	self.owner().unregisterSource(self)
